'use strict';

exports.__esModule = true;
exports.default = loadBabelLibs;

var _nodeVersion = require('../../utils/node-version');

var _nodeVersion2 = _interopRequireDefault(_nodeVersion);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getOptsForPresetEnv() {
    var opts = { targets: { node: 'current' }, loose: true };

    // NOTE: Disable transforming generators into state-machine for node>=4, because this versions have native generators.
    // Also this versions have native template literals, regenerator do not work with them:
    // https://github.com/facebook/regenerator/issues/276
    if (_nodeVersion2.default >= 4) opts.exclude = ['transform-regenerator'];

    return opts;
}

// NOTE: lazy load heavy dependencies
function loadBabelLibs() {
    return {
        babel: require('babel-core'),
        presetStage2: require('babel-preset-stage-2'),
        transformRuntime: require('babel-plugin-transform-runtime'),
        presetFallback: require('babel-preset-env').default(null, { loose: true }),
        presetEnv: require('babel-preset-env').default(null, getOptsForPresetEnv())
    };
}
module.exports = exports['default'];